VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Object = "{E7BC34A0-BA86-11CF-84B1-CBC2DA68BF6C}#1.0#0"; "ntsvc.ocx"
Begin VB.Form ServiceMain 
   Caption         =   "www.activeVB.de - Beispiel Windows NT Service"
   ClientHeight    =   4140
   ClientLeft      =   1395
   ClientTop       =   1620
   ClientWidth     =   6690
   Icon            =   "sample.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'ZReihenfolge
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Begin VB.Timer Timer 
      Left            =   720
      Top             =   3120
   End
   Begin NTService.NTService NTService1 
      Left            =   240
      Top             =   3120
      _Version        =   65536
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   0
      DisplayName     =   "Beispiel Service"
      ServiceName     =   "Beispiel"
      StartMode       =   3
   End
   Begin ComctlLib.StatusBar StatusBar 
      Align           =   2  'Unten ausrichten
      Height          =   300
      Left            =   0
      TabIndex        =   0
      Top             =   3840
      Width           =   6690
      _ExtentX        =   11800
      _ExtentY        =   529
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   2
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            TextSave        =   ""
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
         BeginProperty Panel2 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            TextSave        =   ""
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "ServiceMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Basiert auf einem Code aus der MSDN-Library.
 
 
'(C) MSDN
'TITLE: An OLE Control for Creating Win32 Services in Visual Basic
'Mauricio Ordez
'Microsoft Consulting Services
'June 1996

Private Declare Sub DebugBreak Lib "kernel32" ()
 
Option Explicit
 
Private Sub Form_Load()
 
On Error GoTo Err_Load
    Dim strDisplayName As String
    Dim bStarted As Boolean
    
    strDisplayName = NTService1.DisplayName
    
    StatusBar.Panels(1).Text = "Starte..."
    
    ' Befehle zur Interaktion mit dem Desktop
    If Command = "-install" Then
        'Installieren
        NTService1.Interactive = True
        
        If NTService1.Install Then
            Call NTService1.SaveSetting("Parameters", _
                "TimerInterval", "1000")
            MsgBox strDisplayName & " erfolgreich installiert."
        Else
            MsgBox strDisplayName & " konnte nicht installiert werden."
        End If
        End
    ElseIf Command = "-uninstall" Then
        'Deinstallieren
        If NTService1.Uninstall Then
            MsgBox strDisplayName & " erfolgreich deinstalliert."
        Else
            MsgBox strDisplayName & " konnte nicht deinstalliert werden."
        End If
        End
    ElseIf Command = "-debug" Then
        NTService1.Debug = True
    ElseIf Command <> "" Then
        MsgBox "Unbekannter Kommandozeilenparameter"
        End
    End If
    
    StatusBar.Panels(1).Text = "Lade Konfiguration"
    Dim parmInterval As String
    parmInterval = NTService1.GetSetting("Parameters", _
            "TimerInterval", "2000")
    Timer.Interval = CLng(parmInterval)
    
    ' Pause/Fortfahren muss initialisiert werden, bevor
    ' StartService aufgerufen wurde oder man sich im
    ' Design Modus befindet
    StatusBar.Panels(1).Text = "Steuerungsmodus aktiviert"
    NTService1.ControlsAccepted = svcCtrlPauseContinue
    
    ' Service zum "Windows NT services controller" verbinden
    StatusBar.Panels(1).Text = "Starte Verbindung"
    NTService1.StartService
    Exit Sub

Err_Load:
    If NTService1.Interactive Then
        MsgBox "[" & Err.Number & "] " & Err.Description
        End
    Else
        Call NTService1.LogEvent(svcMessageError, svcEventError, "[" _
            & Err.Number & "] " & Err.Description)
    End If
End Sub
 
 
Private Sub NTService1_Continue(Success As Boolean)
On Error GoTo Err_Continue
    
    Timer.Enabled = True
    StatusBar.Panels(1).Text = "Fortgefahren"
    Success = True
    Call NTService1.LogEvent(svcEventInformation, svcMessageInfo, _
            "Service fortgefahren")
      Exit Sub

Err_Continue:
    Call NTService1.LogEvent(svcMessageError, svcEventError, "[" & _
        Err.Number & "] " & Err.Description)
End Sub
 
Private Sub NTService1_Control(ByVal e As Long)
On Error GoTo Err_Control
    
    StatusBar.SimpleText = NTService1.DisplayName & " " & _
            "Steuerungssignal " & e
   Exit Sub

Err_Control:
    Call NTService1.LogEvent(svcMessageError, svcEventError, "[" & _
        Err.Number & "] " & Err.Description)
End Sub
 
 
Private Sub NTService1_Pause(Success As Boolean)
On Error GoTo Err_Pause
    
    Timer.Enabled = False
    StatusBar.Panels(1).Text = "Pausiert"
    Call NTService1.LogEvent(svcEventError, svcMessageError, "Service " & _
            "pausiert")
    Success = True
      Exit Sub

Err_Pause:
    Call NTService1.LogEvent(svcMessageError, svcEventError, "[" & _
        Err.Number & "] " & Err.Description)
End Sub
 
 
Private Sub NTService1_Start(Success As Boolean)
On Error GoTo Err_Start
    
    StatusBar.Panels(1).Text = "Ok"
    Success = True
      Exit Sub

Err_Start:
    Call NTService1.LogEvent(svcMessageError, svcEventError, "[" & _
        Err.Number & "] " & Err.Description)
End Sub
 
 
Private Sub NTService1_Stop()
On Error GoTo Err_Stop
    
    StatusBar.Panels(1).Text = "Gestoppt"
    Unload Me
      Exit Sub

Err_Stop:
    Call NTService1.LogEvent(svcMessageError, svcEventError, "[" & _
        Err.Number & "] " & Err.Description)
End Sub
 
 
Private Sub Timer_Timer()
On Error GoTo Err_Timer
    StatusBar.Panels(2).Text = Format(Now(), "hh:mm:ss")
   Exit Sub

Err_Timer:
    Call NTService1.LogEvent(svcMessageError, svcEventError, "[" & _
        Err.Number & "] " & Err.Description)
End Sub

